module FuckBot
  class Client
    attr_reader :token, :user, :url, :ws, :store

    def initialize(options = {})
      @token  = options.fetch(:token, ENV['FUCK_BOT_TOKEN'])
      @logger = options.fetch(:logger, Logger.new(STDOUT))
      @store  = FuckBot::Store.new(options[:store])

      rtm_start
    end

    def run
      @ws = Faye::WebSocket::Client.new(@url)

      @ws.on(:open, on_open)
      @ws.on(:message, on_message)
      @ws.on(:close, on_close)
    end

    private

      def on_open
        lambda do |_event|
          @logger.info(:open)
        end
      end

      def on_message
        lambda do |event|
          data = Oj.load(event.data)

          @logger.info(data.inspect)

          MessageResolver.new(data, self).call
        end
      end

      def on_close
        lambda do |_event|
          @logger.info(:close)

          EM.stop
        end
      end

      def rtm_start
        response = RestClient.post(
          'https://slack.com/api/rtm.start',
          token: @token,
          simple_latest: true,
          no_unreads: true
        )

        response = Oj.load(response.body)

        @user = response['self']
        @url = response['url']
      end
  end
end
